#include <cassert>
#include <iostream>
#include <map>
#include <utility>
#include <vector>

using namespace std;

struct node {
  vector<pair<int, node*>> children;
  int amt;
};
node* makenode() {
  node* ret = new node;
  ret->children.clear(); // ?
  ret->amt = 0;
  return ret;
}
int getamt(node* root, const vector<int>& vals) {
  for(auto out: vals) {
    auto it = lower_bound(root->children.begin(), root->children.end(), make_pair(out, (node*)NULL));
    if(it == root->children.end() || it->first != out) return 0;
    root = it->second;
  }
  return root->amt;
}
void insert(node* root, const vector<int>& vals) {
  root->amt++;
  for(auto out: vals) {
    auto it = lower_bound(root->children.begin(), root->children.end(), make_pair(out, (node*)NULL));
    if(it == root->children.end() || it->first != out) {
      int idx = it - root->children.begin();
      root->children.insert(it, make_pair(out, makenode()));
      it = root->children.begin() + idx;
    }
    assert(it->first == out);
    root = it->second;
    root->amt++;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int n, q;
  cin >> n >> q;
  node* ptrie = makenode();
  node* strie = makenode();
  node* btrie = makenode();
  for(int i = 0; i < n; i++) {
    string s;
    cin >> s;
    vector<int> pv, sv, bv;
    for(int a = 0; a < (int)s.size(); a++) {
      pv.push_back(s[a] - 'a');
      sv.push_back(s[s.size()-1-a] - 'a');
      bv.push_back(26 * pv.back() + sv.back());
    }
    insert(ptrie, pv);
    insert(strie, sv);
    insert(btrie, bv);
  }
  map<tuple<string, string, string>, int> dp;
  while(q--) {
    tuple<string, string, string> key;
    cin >> get<0>(key);
    cin >> get<1>(key);
    cin >> get<2>(key);
    if(dp.count(key)) {
      cout << dp[key] << "\n";
      continue;
    }
    string& ch = get<0>(key);
    string& ps = get<1>(key);
    string& ss = get<2>(key);
    int ret = 0;
    if(ch == "AND") {
      vector<int> vals;
      for(int i = 0; i < (int)ps.size(); i++) {
        vals.push_back(26 * (ps[i] - 'a') + (ss[ss.size()-1-i] - 'a'));
      }
      ret = getamt(btrie, vals);
    }
    else if(ch == "OR") {
      vector<int> pv, sv, bv;
      for(int a = 0; a < (int)ss.size(); a++) {
        pv.push_back(ps[a] - 'a');
        sv.push_back(ss[ss.size()-1-a] - 'a');
        bv.push_back(26 * pv.back() + sv.back());
      }
      ret = getamt(ptrie, pv) + getamt(strie, sv) - getamt(btrie, bv);
    }
    else if(ch == "XOR") {
      vector<int> pv, sv, bv;
      for(int a = 0; a < (int)ss.size(); a++) {
        pv.push_back(ps[a] - 'a');
        sv.push_back(ss[ss.size()-1-a] - 'a');
        bv.push_back(26 * pv.back() + sv.back());
      }
      ret = getamt(ptrie, pv) + getamt(strie, sv) - 2 * getamt(btrie, bv);
    }
    else assert(false);
    dp[key] = ret;
    cout << ret << "\n";
  }
}